// MIDI Humanizer GUI
// Team La-a
// 20111104

package ladasha.GUI;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import java.io.*;
import javax.imageio.*;
import ladasha.io.*;
import ladasha.statistics.*;
//import ladasha.processes.*;

public class GUI {
  // globals, yo
  private static String currentPane = "0"; // first card
  private static int currentPaneIndex = 0; // internal representation
  private static int lastPaneIndex = 5; // last card
  private static JPanel cardpanel; // panel to contain cards
  private static File selectedFile; // the selected file to work on
  private static JButton next; // next button, control panel
  private static JButton prev; // previous button, control panel
  private static JButton help; // help button, control panel
  private static JLabel bottom;
  private static BufferedImage image;
  private static BufferedImage image2;
  private static BufferedImage image3;
  private static BufferedImage image4;
  private static BufferedImage image5;
  private static MidiFileHandler midifilehandler = MidiFileHandler.getInstance();
  
  private static void createAndShowGUI() {
    /***************************************************************************
     * Frame Initialization code - Don't touch this except for the size
     **************************************************************************/
    JFrame frame = new JFrame("MIDI Humanizer, by Team La-a");
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setIconImage(new ImageIcon("icon.png").getImage());
    frame.setSize(600,450);
   
    /***************************************************************************
     * All the cards - do your work here
     ***************************************************************************
     * Welcome card (index 0)
    ***************************************************************************/
    
    //load images
    try {
      image = ImageIO.read(new File("MIDI.png"));
    } catch (IOException io) {}
    
    //instantiate and define settings for components
    JLabel card0label = new JLabel(new ImageIcon(image));
    JPanel card0 = new JPanel(new FlowLayout(FlowLayout.CENTER,200,100));
    
    //put everything together
    card0.add(card0label);
    
    /***************************************************************************
     * File selection card (index 1)
     **************************************************************************/

    //load images
    try {
      image4 = ImageIO.read(new File("play.png"));
      image5 = ImageIO.read(new File("stop.png"));
    } catch (IOException io) {}

    //instantiate and define settings for components
    final JPanel card1 = new JPanel(new BorderLayout());
    final JPanel card1top = new JPanel(new FlowLayout(FlowLayout.CENTER));
    final JPanel card1center = new JPanel(new FlowLayout(FlowLayout.CENTER,200,40));
    final JPanel card1ctop = new JPanel(new FlowLayout(FlowLayout.CENTER,10,10));
    final JPanel card1cbottom = new JPanel(new FlowLayout(FlowLayout.RIGHT));
    final JLabel fileLabel = new JLabel("For the first step, select a MIDI file to work on by clicking the button below.");
    final JLabel selectedFileLabel = new JLabel("<no file selected>");
    final JButton fileSelectButton = new JButton("Select a file");
    final JButton initialPreviewButton = new JButton(new ImageIcon(image4));
    final JButton stopButton = new JButton(new ImageIcon(image5));
    final JFileChooser fc = new JFileChooser();
    fc.setFileFilter(new FileNameExtensionFilter("MIDI Files","midi", "mid"));
    initialPreviewButton.setEnabled(false);
    stopButton.setVisible(false);

  
    //assemble components
    card1.add(card1top,BorderLayout.NORTH);
    card1.add(card1center,BorderLayout.CENTER);
    card1top.add(fileLabel);
    card1ctop.add(fileSelectButton);
    card1cbottom.add(selectedFileLabel);
    card1cbottom.add(initialPreviewButton);
    card1cbottom.add(stopButton);
    card1center.add(card1ctop);
    card1center.add(card1cbottom);
        
    // add listeners
    fileSelectButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          fc.showOpenDialog(card1);
        } catch (HeadlessException ex) {}
        selectedFile = fc.getSelectedFile();
        if (selectedFile.toString().endsWith(".mid") || selectedFile.toString().endsWith(".midi")) {
          selectedFileLabel.setText(selectedFile.getAbsolutePath());
          initialPreviewButton.setEnabled(true);
	    }
      }
    });
    
    initialPreviewButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if(!midifilehandler.loadMidiFile(selectedFile)) return; // load file, break on failure
        else {
          initialPreviewButton.setVisible(false);
          stopButton.setVisible(true);
          midifilehandler.previewUntilStop(); // play preview
        }
      }
    });

    

    stopButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        // stop the loaded file
	    midifilehandler.stop();
        stopButton.setVisible(false);
        initialPreviewButton.setVisible(true);
      }
    });
  
    
   
    /***************************************************************************
     * Profile selection card (index 2)
     **************************************************************************/
    
    //load images

    //instantiate and define settings for components
    JPanel card2 = new JPanel();
    JLabel card2label = new JLabel("This is the profile selection card");
    
    //assemble components
    card2.add(card2label);

    //add listeners
    
    /***************************************************************************
     * Parameter selection card (index 3)
     **************************************************************************/

    //load images

    
    //instantiate and define settings for components
    JPanel card3 = new JPanel();
    JLabel card3label = new JLabel("This is the parameter selection card");
    
    //assemble components
    card3.add(card3label);
    
    //add listeners
    
    /***************************************************************************
     * Preview card (index 4)
     **************************************************************************/

    //load images

    //instantiate and define settings for components
    JPanel card4 = new JPanel();
    JLabel card4label = new JLabel("This is the preview card");

    //assemble components
    card4.add(card4label);

    //add listeners

    /***************************************************************************
     * Finalize/save card (index 5)
     **************************************************************************/

    //load images
    
    //instantiate and define settings for components
    JPanel card5 = new JPanel();
    JLabel card5label = new JLabel("This is the save card");
    
    //assemble components
    card5.add(card5label);
    
    //add listeners

    /***************************************************************************
     * cards (help pages) index = prevpage + 10
     * Welcome help card (index 10)
     **************************************************************************/
    
    //load images

    //instantiate and define settings for components
    JPanel card10 = new JPanel();
    JLabel card10label = new JLabel("MIDI Humanizer Help");

    //assemble components
    card10.add(card10label);
    
    //add listeners

    /***************************************************************************
     * File Selection help card (index 11)
     **************************************************************************/
    
    //load images
    
    //instantiate and define settings for components
    JPanel card11 = new JPanel();
    JLabel card11label = new JLabel("This is help for the file selection card.");

    //assemble components
    card11.add(card11label);

    //add listeners
    
    /***************************************************************************
     * Profile Selection card (index 12)
     **************************************************************************/
    
    //load images

    //instantiate and define settings for components
    JPanel card12 = new JPanel();
    JLabel card12label = new JLabel("This is the help for the profile selection card");

    //assemble components
    card12.add(card12label);
    
    //add listeners

    /***************************************************************************
     * Parameter Selection help card (index 13)
     **************************************************************************/
    
    //load images

    //instantiate and define settings for components
    JPanel card13 = new JPanel();
    JLabel card13label = new JLabel("This is the help for the parameter selection card");

    //assemble components
    card13.add(card13label);

    //add listeners
    
    /***************************************************************************
     * Preview help card (index 14)
     **************************************************************************/
    
    //load images
    
    //instantiate and define settings for components
    JPanel card14 = new JPanel();
    JLabel card14label = new JLabel("This is the help for the preview card");
    
    //assemble components
    card14.add(card14label);
    
    //add listeners

    /***************************************************************************
     * Finalize/Save help card (index 15)
     **************************************************************************/
    
    //load images

    //instantiate and define settings for components
    JPanel card15 = new JPanel();
    JLabel card15label = new JLabel("This is the help for the save card");
    
    //assemble components
    card15.add(card15label);
    
    //add listeners
    

    // assemble all the cards into the panel
    cardpanel = new JPanel(new CardLayout());
    cardpanel.add(card0,"0");
    cardpanel.add(card1,"1");
    cardpanel.add(card2,"2");
    cardpanel.add(card3,"3");
    cardpanel.add(card4,"4");
    cardpanel.add(card5,"5");
    cardpanel.add(card10,"10");
    cardpanel.add(card11,"11");
    cardpanel.add(card12,"12");
    cardpanel.add(card13,"13");
    cardpanel.add(card14,"14");
    cardpanel.add(card15,"15");
    
    
    /***************************************************************************
     * Control Panel Code (bottom button panel)
     **************************************************************************/
    
    //load images
    try {
            image2 = ImageIO.read(new File("MIDI2.png"));
            image3 = ImageIO.read(new File("help.png"));
    } catch (IOException io) {}
    
    //instantiate and define settings for components
    JPanel controlPanel = new JPanel(new BorderLayout());
    JPanel controls = new JPanel(new FlowLayout(FlowLayout.CENTER));
    next = new JButton("Next-->");
    prev = new JButton("<--Previous");
    bottom = new JLabel(new ImageIcon(image2));
    help = new JButton(new ImageIcon(image3));
    
    //assemble components
    controlPanel.add(help,BorderLayout.WEST);
    controls.add(prev);
    controls.add(next);
    controlPanel.add(controls,BorderLayout.CENTER);
    controlPanel.add(bottom,BorderLayout.EAST);

    // add listeners for controls
    next.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CardLayout cl = (CardLayout)(cardpanel.getLayout());
        currentPaneIndex++;
        if (currentPaneIndex > lastPaneIndex) currentPaneIndex = lastPaneIndex;
        currentPane = Integer.toString(currentPaneIndex);
        cl.show(cardpanel, currentPane);
        initializeCard(currentPaneIndex);
      }
    });
    
    prev.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CardLayout cl = (CardLayout)(cardpanel.getLayout());
        if (currentPaneIndex <= lastPaneIndex)
          currentPaneIndex--;
        else
          currentPaneIndex -= 10;
        if (currentPaneIndex < 0) currentPaneIndex = 0;
        currentPane = Integer.toString(currentPaneIndex);
        cl.show(cardpanel, currentPane);
        initializeCard(currentPaneIndex);
      }
    });

    help.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        CardLayout cl = (CardLayout)(cardpanel.getLayout());
        currentPaneIndex += 10;
        if (currentPaneIndex >= lastPaneIndex+10) currentPaneIndex = lastPaneIndex+10;
        currentPane = Integer.toString(currentPaneIndex);
        cl.show(cardpanel, currentPane);
        initializeCard(currentPaneIndex);
      }
    });
    
    /***************************************************************************
     * GUI Initialization Code
     * Perform any tasks that need to be done before the GUI is shown here
     **************************************************************************/
    
    // build the gui, finally
    frame.getContentPane().add(cardpanel, BorderLayout.CENTER);
    frame.getContentPane().add(controlPanel, BorderLayout.SOUTH);
    
    // start on correct card
    CardLayout cl = (CardLayout)(cardpanel.getLayout());
    cl.show(cardpanel,currentPane);
    initializeCard(currentPaneIndex);
    
    // display the frame
    //frame.pack();
    frame.setVisible(true);
    frame.setResizable(false);
  }
  
  /*****************************************************************************
   * initializeCard() Method
   * this is called whenever a new card is placed on the screen
   * be careful with this, and don't touch the breaks
   ****************************************************************************/

  static public void initializeCard(int index) {
    switch(index) {
      case 0:
        next.setText("Let's Get Started");
        prev.setText("<--Previous");
        next.setEnabled(true);
        next.setVisible(true);
        prev.setEnabled(false);
        prev.setVisible(false);
        help.setEnabled(true);
        help.setVisible(true);
	bottom.setVisible(false);
	break;
      case 1: case 2: case 3:
        next.setText("Next-->");
        prev.setText("<--Previous");
        next.setEnabled(true);
        next.setVisible(true);
        prev.setEnabled(true);
        prev.setVisible(true);
        help.setEnabled(true);
        help.setVisible(true);
	bottom.setVisible(true);
        break;
      case 4:
        next.setText("Finish!");
        prev.setText("<--Previous");
        next.setEnabled(true);
        next.setVisible(true);
        prev.setEnabled(true);
        prev.setVisible(true);
        help.setEnabled(true);
        help.setVisible(true);
	bottom.setVisible(true);
        break;
      case 5:
        prev.setText("<--Previous");
        next.setEnabled(false);
        next.setVisible(false);
        prev.setEnabled(true);
        prev.setVisible(true);
        help.setEnabled(true);
        help.setVisible(true);
	bottom.setVisible(true);
        break;
      case 10: case 11: case 12: case 13: case 14: case 15:
        prev.setText("Close Help");
        next.setEnabled(false);
        next.setVisible(false);
        prev.setEnabled(true);
        prev.setVisible(true);
        help.setEnabled(false);
        help.setVisible(false);
	bottom.setVisible(true);
        break;
      default:
        // shouldn't get here
        System.out.println("How did you end up here?  Index: " + index);
	bottom.setVisible(true);
        break;
    }
  }
  
  /*****************************************************************************
   * main() Method - Don't touch this
   ****************************************************************************/
  static public void main(String[] args) {
    // Use the system's Look and Feel
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    } catch (UnsupportedLookAndFeelException ex) {
      ex.printStackTrace();
    } catch (IllegalAccessException ex) {
      ex.printStackTrace();
    } catch (InstantiationException ex) {
      ex.printStackTrace();
    } catch (ClassNotFoundException ex) {
      ex.printStackTrace();
    }
    
    javax.swing.SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        createAndShowGUI();
      }
    });
  }
}
