package ladasha.io;

import java.io.File;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;


public class MidiFileHandler {	
  private File file = null;
  private Sequencer seq1 = null;
  private Sequence seq = null;
  private static MidiFileHandler instance = null;

  private MidiFileHandler() {}
  
  public static MidiFileHandler getInstance() {
    if(instance == null) instance = new MidiFileHandler();
    return instance;
  }

  public boolean loadMidiFile(File cake) {
    this.file = cake;
    if(file == null) return false; // throw exception here in the future
    try{        
      // sets up the sequencer
      seq1 = MidiSystem.getSequencer();
      if(seq1 == null) {
        return false; // throw exception here in the future
      } else { 
        // get resources to get midi
        seq1.open();
      }
      // sequencer gets file
      seq =  MidiSystem.getSequence(cake);
      seq1.setSequence(seq);
    } catch(Exception ex) {
      ex.printStackTrace();
    }
    return true;
  } // end method
  
  public Sequence getMidiSequence() {
    if(seq == null)
      return null; // throw exception here in the future
    else
      return seq;
  }
  
  public void stop() {
    if(seq1==null) return; // throw exception here in the future
    try {
      seq1.stop();
    } catch (Exception ex) { ex.printStackTrace(); }
  }

  public void preview(int millis) {
    if(seq1==null) return; // throw exception here in the future
    try{
      Thread t = new Thread(new Runnable() {
      	public void run() { 
      	seq1.start();  }
      });
      t.start();
      // lets the song get previewed for (millis/1000) sec
      Thread.sleep(millis);
      seq1.stop();
    } catch(Exception ex){
      ex.printStackTrace();
    }
  }
  
  public void preview() {
    preview(10000);
  }
  
  public void previewUntilStop() {
    if(seq1==null) return; // throw exception here in the future
    try{
      Thread t = new Thread(new Runnable() {
      	public void run() { 
      	seq1.start();  }
      });
      t.start();
    } catch(Exception ex){
      ex.printStackTrace();
    }
  }
}// end class
